"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.UntagResourcesOutput = exports.UntagResourcesInput = exports.TagResourcesOutput = exports.TagResourcesInput = exports.StartReportCreationOutput = exports.StartReportCreationInput = exports.GetTagValuesOutput = exports.GetTagValuesInput = exports.GetTagKeysOutput = exports.GetTagKeysInput = exports.PaginationTokenExpiredException = exports.GetResourcesOutput = exports.ResourceTagMapping = exports.Tag = exports.GetResourcesInput = exports.TagFilter = exports.GetComplianceSummaryOutput = exports.Summary = exports.TargetIdType = exports.GetComplianceSummaryInput = exports.GroupByAttribute = exports.FailureInfo = exports.ErrorCode = exports.ThrottledException = exports.InvalidParameterException = exports.InternalServiceException = exports.DescribeReportCreationOutput = exports.DescribeReportCreationInput = exports.ConstraintViolationException = exports.ConcurrentModificationException = exports.ComplianceDetails = void 0;
const ResourceGroupsTaggingAPIServiceException_1 = require("./ResourceGroupsTaggingAPIServiceException");
var ComplianceDetails;
(function (ComplianceDetails) {
    ComplianceDetails.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(ComplianceDetails = exports.ComplianceDetails || (exports.ComplianceDetails = {}));
class ConcurrentModificationException extends ResourceGroupsTaggingAPIServiceException_1.ResourceGroupsTaggingAPIServiceException {
    constructor(opts) {
        super({
            name: "ConcurrentModificationException",
            $fault: "client",
            ...opts,
        });
        this.name = "ConcurrentModificationException";
        this.$fault = "client";
        Object.setPrototypeOf(this, ConcurrentModificationException.prototype);
        this.Message = opts.Message;
    }
}
exports.ConcurrentModificationException = ConcurrentModificationException;
class ConstraintViolationException extends ResourceGroupsTaggingAPIServiceException_1.ResourceGroupsTaggingAPIServiceException {
    constructor(opts) {
        super({
            name: "ConstraintViolationException",
            $fault: "client",
            ...opts,
        });
        this.name = "ConstraintViolationException";
        this.$fault = "client";
        Object.setPrototypeOf(this, ConstraintViolationException.prototype);
        this.Message = opts.Message;
    }
}
exports.ConstraintViolationException = ConstraintViolationException;
var DescribeReportCreationInput;
(function (DescribeReportCreationInput) {
    DescribeReportCreationInput.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(DescribeReportCreationInput = exports.DescribeReportCreationInput || (exports.DescribeReportCreationInput = {}));
var DescribeReportCreationOutput;
(function (DescribeReportCreationOutput) {
    DescribeReportCreationOutput.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(DescribeReportCreationOutput = exports.DescribeReportCreationOutput || (exports.DescribeReportCreationOutput = {}));
class InternalServiceException extends ResourceGroupsTaggingAPIServiceException_1.ResourceGroupsTaggingAPIServiceException {
    constructor(opts) {
        super({
            name: "InternalServiceException",
            $fault: "server",
            ...opts,
        });
        this.name = "InternalServiceException";
        this.$fault = "server";
        Object.setPrototypeOf(this, InternalServiceException.prototype);
        this.Message = opts.Message;
    }
}
exports.InternalServiceException = InternalServiceException;
class InvalidParameterException extends ResourceGroupsTaggingAPIServiceException_1.ResourceGroupsTaggingAPIServiceException {
    constructor(opts) {
        super({
            name: "InvalidParameterException",
            $fault: "client",
            ...opts,
        });
        this.name = "InvalidParameterException";
        this.$fault = "client";
        Object.setPrototypeOf(this, InvalidParameterException.prototype);
        this.Message = opts.Message;
    }
}
exports.InvalidParameterException = InvalidParameterException;
class ThrottledException extends ResourceGroupsTaggingAPIServiceException_1.ResourceGroupsTaggingAPIServiceException {
    constructor(opts) {
        super({
            name: "ThrottledException",
            $fault: "client",
            ...opts,
        });
        this.name = "ThrottledException";
        this.$fault = "client";
        Object.setPrototypeOf(this, ThrottledException.prototype);
        this.Message = opts.Message;
    }
}
exports.ThrottledException = ThrottledException;
var ErrorCode;
(function (ErrorCode) {
    ErrorCode["INTERNAL_SERVICE_EXCEPTION"] = "InternalServiceException";
    ErrorCode["INVALID_PARAMETER_EXCEPTION"] = "InvalidParameterException";
})(ErrorCode = exports.ErrorCode || (exports.ErrorCode = {}));
var FailureInfo;
(function (FailureInfo) {
    FailureInfo.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(FailureInfo = exports.FailureInfo || (exports.FailureInfo = {}));
var GroupByAttribute;
(function (GroupByAttribute) {
    GroupByAttribute["REGION"] = "REGION";
    GroupByAttribute["RESOURCE_TYPE"] = "RESOURCE_TYPE";
    GroupByAttribute["TARGET_ID"] = "TARGET_ID";
})(GroupByAttribute = exports.GroupByAttribute || (exports.GroupByAttribute = {}));
var GetComplianceSummaryInput;
(function (GetComplianceSummaryInput) {
    GetComplianceSummaryInput.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(GetComplianceSummaryInput = exports.GetComplianceSummaryInput || (exports.GetComplianceSummaryInput = {}));
var TargetIdType;
(function (TargetIdType) {
    TargetIdType["ACCOUNT"] = "ACCOUNT";
    TargetIdType["OU"] = "OU";
    TargetIdType["ROOT"] = "ROOT";
})(TargetIdType = exports.TargetIdType || (exports.TargetIdType = {}));
var Summary;
(function (Summary) {
    Summary.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(Summary = exports.Summary || (exports.Summary = {}));
var GetComplianceSummaryOutput;
(function (GetComplianceSummaryOutput) {
    GetComplianceSummaryOutput.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(GetComplianceSummaryOutput = exports.GetComplianceSummaryOutput || (exports.GetComplianceSummaryOutput = {}));
var TagFilter;
(function (TagFilter) {
    TagFilter.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(TagFilter = exports.TagFilter || (exports.TagFilter = {}));
var GetResourcesInput;
(function (GetResourcesInput) {
    GetResourcesInput.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(GetResourcesInput = exports.GetResourcesInput || (exports.GetResourcesInput = {}));
var Tag;
(function (Tag) {
    Tag.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(Tag = exports.Tag || (exports.Tag = {}));
var ResourceTagMapping;
(function (ResourceTagMapping) {
    ResourceTagMapping.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(ResourceTagMapping = exports.ResourceTagMapping || (exports.ResourceTagMapping = {}));
var GetResourcesOutput;
(function (GetResourcesOutput) {
    GetResourcesOutput.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(GetResourcesOutput = exports.GetResourcesOutput || (exports.GetResourcesOutput = {}));
class PaginationTokenExpiredException extends ResourceGroupsTaggingAPIServiceException_1.ResourceGroupsTaggingAPIServiceException {
    constructor(opts) {
        super({
            name: "PaginationTokenExpiredException",
            $fault: "client",
            ...opts,
        });
        this.name = "PaginationTokenExpiredException";
        this.$fault = "client";
        Object.setPrototypeOf(this, PaginationTokenExpiredException.prototype);
        this.Message = opts.Message;
    }
}
exports.PaginationTokenExpiredException = PaginationTokenExpiredException;
var GetTagKeysInput;
(function (GetTagKeysInput) {
    GetTagKeysInput.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(GetTagKeysInput = exports.GetTagKeysInput || (exports.GetTagKeysInput = {}));
var GetTagKeysOutput;
(function (GetTagKeysOutput) {
    GetTagKeysOutput.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(GetTagKeysOutput = exports.GetTagKeysOutput || (exports.GetTagKeysOutput = {}));
var GetTagValuesInput;
(function (GetTagValuesInput) {
    GetTagValuesInput.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(GetTagValuesInput = exports.GetTagValuesInput || (exports.GetTagValuesInput = {}));
var GetTagValuesOutput;
(function (GetTagValuesOutput) {
    GetTagValuesOutput.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(GetTagValuesOutput = exports.GetTagValuesOutput || (exports.GetTagValuesOutput = {}));
var StartReportCreationInput;
(function (StartReportCreationInput) {
    StartReportCreationInput.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(StartReportCreationInput = exports.StartReportCreationInput || (exports.StartReportCreationInput = {}));
var StartReportCreationOutput;
(function (StartReportCreationOutput) {
    StartReportCreationOutput.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(StartReportCreationOutput = exports.StartReportCreationOutput || (exports.StartReportCreationOutput = {}));
var TagResourcesInput;
(function (TagResourcesInput) {
    TagResourcesInput.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(TagResourcesInput = exports.TagResourcesInput || (exports.TagResourcesInput = {}));
var TagResourcesOutput;
(function (TagResourcesOutput) {
    TagResourcesOutput.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(TagResourcesOutput = exports.TagResourcesOutput || (exports.TagResourcesOutput = {}));
var UntagResourcesInput;
(function (UntagResourcesInput) {
    UntagResourcesInput.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(UntagResourcesInput = exports.UntagResourcesInput || (exports.UntagResourcesInput = {}));
var UntagResourcesOutput;
(function (UntagResourcesOutput) {
    UntagResourcesOutput.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(UntagResourcesOutput = exports.UntagResourcesOutput || (exports.UntagResourcesOutput = {}));
