import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { DescribeReportCreationInput, DescribeReportCreationOutput } from "../models/models_0";
import { deserializeAws_json1_1DescribeReportCreationCommand, serializeAws_json1_1DescribeReportCreationCommand, } from "../protocols/Aws_json1_1";
var DescribeReportCreationCommand = (function (_super) {
    __extends(DescribeReportCreationCommand, _super);
    function DescribeReportCreationCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    DescribeReportCreationCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "ResourceGroupsTaggingAPIClient";
        var commandName = "DescribeReportCreationCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: DescribeReportCreationInput.filterSensitiveLog,
            outputFilterSensitiveLog: DescribeReportCreationOutput.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    DescribeReportCreationCommand.prototype.serialize = function (input, context) {
        return serializeAws_json1_1DescribeReportCreationCommand(input, context);
    };
    DescribeReportCreationCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_json1_1DescribeReportCreationCommand(output, context);
    };
    return DescribeReportCreationCommand;
}($Command));
export { DescribeReportCreationCommand };
