import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { GetComplianceSummaryInput, GetComplianceSummaryOutput } from "../models/models_0";
import { deserializeAws_json1_1GetComplianceSummaryCommand, serializeAws_json1_1GetComplianceSummaryCommand, } from "../protocols/Aws_json1_1";
var GetComplianceSummaryCommand = (function (_super) {
    __extends(GetComplianceSummaryCommand, _super);
    function GetComplianceSummaryCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    GetComplianceSummaryCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "ResourceGroupsTaggingAPIClient";
        var commandName = "GetComplianceSummaryCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: GetComplianceSummaryInput.filterSensitiveLog,
            outputFilterSensitiveLog: GetComplianceSummaryOutput.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    GetComplianceSummaryCommand.prototype.serialize = function (input, context) {
        return serializeAws_json1_1GetComplianceSummaryCommand(input, context);
    };
    GetComplianceSummaryCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_json1_1GetComplianceSummaryCommand(output, context);
    };
    return GetComplianceSummaryCommand;
}($Command));
export { GetComplianceSummaryCommand };
