import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { GetTagKeysInput, GetTagKeysOutput } from "../models/models_0";
import { deserializeAws_json1_1GetTagKeysCommand, serializeAws_json1_1GetTagKeysCommand, } from "../protocols/Aws_json1_1";
var GetTagKeysCommand = (function (_super) {
    __extends(GetTagKeysCommand, _super);
    function GetTagKeysCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    GetTagKeysCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "ResourceGroupsTaggingAPIClient";
        var commandName = "GetTagKeysCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: GetTagKeysInput.filterSensitiveLog,
            outputFilterSensitiveLog: GetTagKeysOutput.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    GetTagKeysCommand.prototype.serialize = function (input, context) {
        return serializeAws_json1_1GetTagKeysCommand(input, context);
    };
    GetTagKeysCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_json1_1GetTagKeysCommand(output, context);
    };
    return GetTagKeysCommand;
}($Command));
export { GetTagKeysCommand };
