import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { StartReportCreationInput, StartReportCreationOutput } from "../models/models_0";
import { deserializeAws_json1_1StartReportCreationCommand, serializeAws_json1_1StartReportCreationCommand, } from "../protocols/Aws_json1_1";
var StartReportCreationCommand = (function (_super) {
    __extends(StartReportCreationCommand, _super);
    function StartReportCreationCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    StartReportCreationCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "ResourceGroupsTaggingAPIClient";
        var commandName = "StartReportCreationCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: StartReportCreationInput.filterSensitiveLog,
            outputFilterSensitiveLog: StartReportCreationOutput.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    StartReportCreationCommand.prototype.serialize = function (input, context) {
        return serializeAws_json1_1StartReportCreationCommand(input, context);
    };
    StartReportCreationCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_json1_1StartReportCreationCommand(output, context);
    };
    return StartReportCreationCommand;
}($Command));
export { StartReportCreationCommand };
