import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { TagResourcesInput, TagResourcesOutput } from "../models/models_0";
import { deserializeAws_json1_1TagResourcesCommand, serializeAws_json1_1TagResourcesCommand, } from "../protocols/Aws_json1_1";
var TagResourcesCommand = (function (_super) {
    __extends(TagResourcesCommand, _super);
    function TagResourcesCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    TagResourcesCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "ResourceGroupsTaggingAPIClient";
        var commandName = "TagResourcesCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: TagResourcesInput.filterSensitiveLog,
            outputFilterSensitiveLog: TagResourcesOutput.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    TagResourcesCommand.prototype.serialize = function (input, context) {
        return serializeAws_json1_1TagResourcesCommand(input, context);
    };
    TagResourcesCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_json1_1TagResourcesCommand(output, context);
    };
    return TagResourcesCommand;
}($Command));
export { TagResourcesCommand };
