import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { UntagResourcesInput, UntagResourcesOutput } from "../models/models_0";
import { deserializeAws_json1_1UntagResourcesCommand, serializeAws_json1_1UntagResourcesCommand, } from "../protocols/Aws_json1_1";
var UntagResourcesCommand = (function (_super) {
    __extends(UntagResourcesCommand, _super);
    function UntagResourcesCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    UntagResourcesCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "ResourceGroupsTaggingAPIClient";
        var commandName = "UntagResourcesCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: UntagResourcesInput.filterSensitiveLog,
            outputFilterSensitiveLog: UntagResourcesOutput.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    UntagResourcesCommand.prototype.serialize = function (input, context) {
        return serializeAws_json1_1UntagResourcesCommand(input, context);
    };
    UntagResourcesCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_json1_1UntagResourcesCommand(output, context);
    };
    return UntagResourcesCommand;
}($Command));
export { UntagResourcesCommand };
