import { Command as $Command } from "@aws-sdk/smithy-client";
import { Handler, HttpHandlerOptions as __HttpHandlerOptions, MetadataBearer as __MetadataBearer, MiddlewareStack } from "@aws-sdk/types";
import { StartReportCreationInput, StartReportCreationOutput } from "../models/models_0";
import { ResourceGroupsTaggingAPIClientResolvedConfig, ServiceInputTypes, ServiceOutputTypes } from "../ResourceGroupsTaggingAPIClient";
export interface StartReportCreationCommandInput extends StartReportCreationInput {
}
export interface StartReportCreationCommandOutput extends StartReportCreationOutput, __MetadataBearer {
}

export declare class StartReportCreationCommand extends $Command<StartReportCreationCommandInput, StartReportCreationCommandOutput, ResourceGroupsTaggingAPIClientResolvedConfig> {
    readonly input: StartReportCreationCommandInput;
    constructor(input: StartReportCreationCommandInput);
    
    resolveMiddleware(clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>, configuration: ResourceGroupsTaggingAPIClientResolvedConfig, options?: __HttpHandlerOptions): Handler<StartReportCreationCommandInput, StartReportCreationCommandOutput>;
    private serialize;
    private deserialize;
}
